ur_rna.GUITester.ScriptParser

## Class JavaCharStream

- java.lang.Object
- - ur_rna.GUITester.ScriptParser.JavaCharStream

-     public class JavaCharStream
      extends java.lang.Object

  An implementation of interface CharStream, where the stream is assumed to contain only ASCII characters (with java-like unicode escape processing).

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) int` | `available`
    `protected int[]` | `bufcolumn`
    `protected char[]` | `buffer`
    `protected int[]` | `bufline`
    `int` | `bufpos` Position in buffer.
    `(package private) int` | `bufsize`
    `protected int` | `column`
    `protected int` | `inBuf`
    `protected java.io.Reader` | `inputStream`
    `protected int` | `line`
    `protected int` | `maxNextCharInd`
    `protected char[]` | `nextCharBuf`
    `protected int` | `nextCharInd`
    `protected boolean` | `prevCharIsCR`
    `protected boolean` | `prevCharIsLF`
    `static boolean` | `staticFlag` Whether parser is static.
    `protected int` | `tabSize`
    `(package private) int` | `tokenBegin`
    `protected boolean` | `trackLineColumn`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JavaCharStream(java.io.InputStream dstream)` Constructor.
    `JavaCharStream(java.io.InputStream dstream, int startline, int startcolumn)` Constructor.
    `JavaCharStream(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)` Constructor.
    `JavaCharStream(java.io.InputStream dstream, java.lang.String encoding)` Constructor.
    `JavaCharStream(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn)` Constructor.
    `JavaCharStream(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn, int buffersize)` Constructor.
    `JavaCharStream(java.io.Reader dstream)` Constructor.
    `JavaCharStream(java.io.Reader dstream, int startline, int startcolumn)` Constructor.
    `JavaCharStream(java.io.Reader dstream, int startline, int startcolumn, int buffersize)` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `adjustBeginLineColumn(int newLine, int newCol)` Method to adjust line and column numbers for the start of a token.
    `protected void` | `AdjustBuffSize()`
    `void` | `backup(int amount)` Retreat.
    `char` | `BeginToken()`
    `void` | `Done()` Set buffers back to null when finished.
    `protected void` | `ExpandBuff(boolean wrapAround)`
    `protected void` | `FillBuff()`
    `int` | `getBeginColumn()`
    `int` | `getBeginLine()`
    `int` | `getColumn()` Deprecated.
    `int` | `getEndColumn()` Get end column.
    `int` | `getEndLine()` Get end line.
    `java.lang.String` | `GetImage()`
    `int` | `getLine()` Deprecated.
    `char[]` | `GetSuffix(int len)`
    `int` | `getTabSize()`
    `(package private) boolean` | `getTrackLineColumn()`
    `(package private) static int` | `hexval(char c)`
    `protected char` | `ReadByte()`
    `char` | `readChar()` Read a character.
    `void` | `ReInit(java.io.InputStream dstream)` Reinitialise.
    `void` | `ReInit(java.io.InputStream dstream, int startline, int startcolumn)` Reinitialise.
    `void` | `ReInit(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)` Reinitialise.
    `void` | `ReInit(java.io.InputStream dstream, java.lang.String encoding)` Reinitialise.
    `void` | `ReInit(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn)` Reinitialise.
    `void` | `ReInit(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn, int buffersize)` Reinitialise.
    `void` | `ReInit(java.io.Reader dstream)` Reinitialise.
    `void` | `ReInit(java.io.Reader dstream, int startline, int startcolumn)` Reinitialise.
    `void` | `ReInit(java.io.Reader dstream, int startline, int startcolumn, int buffersize)` Reinitialise.
    `void` | `setTabSize(int i)`
    `(package private) void` | `setTrackLineColumn(boolean tlc)`
    `protected void` | `UpdateLineColumn(char c)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### available

          int available

    - #### bufcolumn

          protected int[] bufcolumn

    - #### buffer

          protected char[] buffer

    - #### bufline

          protected int[] bufline

    - #### bufpos

          public int bufpos

      Position in buffer.

    - #### bufsize

          int bufsize

    - #### column

          protected int column

    - #### inBuf

          protected int inBuf

    - #### inputStream

          protected java.io.Reader inputStream

    - #### line

          protected int line

    - #### maxNextCharInd

          protected int maxNextCharInd

    - #### nextCharBuf

          protected char[] nextCharBuf

    - #### nextCharInd

          protected int nextCharInd

    - #### prevCharIsCR

          protected boolean prevCharIsCR

    - #### prevCharIsLF

          protected boolean prevCharIsLF

    - #### staticFlag

          public static final boolean staticFlag

      Whether parser is static.
      See Also:
        Constant Field Values

    - #### tabSize

          protected int tabSize

    - #### tokenBegin

          int tokenBegin

    - #### trackLineColumn

          protected boolean trackLineColumn

  - ### Constructor Detail

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream,
                                int startline,
                                int startcolumn)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream,
                                int startline,
                                int startcolumn,
                                int buffersize)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream,
                                java.lang.String encoding)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream,
                                java.lang.String encoding,
                                int startline,
                                int startcolumn)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream(java.io.InputStream dstream,
                                java.lang.String encoding,
                                int startline,
                                int startcolumn,
                                int buffersize)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream(java.io.Reader dstream)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream(java.io.Reader dstream,
                                int startline,
                                int startcolumn)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream(java.io.Reader dstream,
                                int startline,
                                int startcolumn,
                                int buffersize)

      Constructor.

  - ### Method Detail

    - #### adjustBeginLineColumn

          public void adjustBeginLineColumn(int newLine,
                                            int newCol)

      Method to adjust line and column numbers for the start of a token.

    - #### AdjustBuffSize

          protected void AdjustBuffSize()

    - #### backup

          public void backup(int amount)

      Retreat.

    - #### BeginToken

          public char BeginToken()
                          throws java.io.IOException

      Returns:
        starting character for token.
      Throws:
        `java.io.IOException`

    - #### Done

          public void Done()

      Set buffers back to null when finished.

    - #### ExpandBuff

          protected void ExpandBuff(boolean wrapAround)

    - #### FillBuff

          protected void FillBuff()
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getBeginColumn

          public int getBeginColumn()

      Returns:
        column of token start

    - #### getBeginLine

          public int getBeginLine()

      Returns:
        line number of token start

    - #### getColumn

          @Deprecated
          public int getColumn()

      Deprecated.

    - #### getEndColumn

          public int getEndColumn()

      Get end column.

    - #### getEndLine

          public int getEndLine()

      Get end line.

    - #### GetImage

          public java.lang.String GetImage()

      Returns:
        token image as String

    - #### getLine

          @Deprecated
          public int getLine()

      Deprecated.

    - #### GetSuffix

          public char[] GetSuffix(int len)

      Returns:
        suffix

    - #### getTabSize

          public int getTabSize()

    - #### getTrackLineColumn

          boolean getTrackLineColumn()

    - #### hexval

          static final int hexval(char c)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### ReadByte

          protected char ReadByte()
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readChar

          public char readChar()
                        throws java.io.IOException

      Read a character.
      Throws:
        `java.io.IOException`

    - #### ReInit

          public void ReInit(java.io.InputStream dstream)

      Reinitialise.

    - #### ReInit

          public void ReInit(java.io.InputStream dstream,
                             int startline,
                             int startcolumn)

      Reinitialise.

    - #### ReInit

          public void ReInit(java.io.InputStream dstream,
                             int startline,
                             int startcolumn,
                             int buffersize)

      Reinitialise.

    - #### ReInit

          public void ReInit(java.io.InputStream dstream,
                             java.lang.String encoding)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit(java.io.InputStream dstream,
                             java.lang.String encoding,
                             int startline,
                             int startcolumn)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit(java.io.InputStream dstream,
                             java.lang.String encoding,
                             int startline,
                             int startcolumn,
                             int buffersize)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit(java.io.Reader dstream)

      Reinitialise.

    - #### ReInit

          public void ReInit(java.io.Reader dstream,
                             int startline,
                             int startcolumn)

      Reinitialise.

    - #### ReInit

          public void ReInit(java.io.Reader dstream,
                             int startline,
                             int startcolumn,
                             int buffersize)

      Reinitialise.

    - #### setTabSize

          public void setTabSize(int i)

    - #### setTrackLineColumn

          void setTrackLineColumn(boolean tlc)

    - #### UpdateLineColumn

          protected void UpdateLineColumn(char c)